#==============================================================================
# 		fichier de D'INSTRUCTIONS de référence
#Julien Brajard
#==============================================================================
#script faisant l'assimilation de référence
#paramètres à régler : TA=50 (48 pdt effectifs)
#NX=32,NY=22,NZ=31
#paramères de contrôle : ta_c
#obs (3D a t=48 Yt=50) : sshb, tb, sb,ub,vb
#

##INITIALISATION
xistate_init 1 ../data_in/file_rest/GYRE_00000424_restart.nc
load_eb ta_c   // pour tenir en compte ta_c sinon sera 0 cause filtre
true_target_in_tab ta_c
xinitnc ../data_out/exp_T.nc

xwriteout 0 true ../data_out/exp_T.nc
#setstate nu 1
init_nu
xset_fdt_fco th 100. 
xset_fdt_fco tz 100.
xset_fdt_fco kh 5.e+02
xset_fdt_fco kz 1.2e-05

print_time OFF
set_modeltime 0
FORWARD
#xwriteout 50 obs_48 ../data_out/exp_T.nc
#savestate gcx_dynspg_flt 1 ijk 0 A 3 ../data_out/gcx_dynspg_flt_jb.dat
#savestate gcb_dynspg_flt 1 ijk 0 A 3 ../data_out/gcb_dynspg_flt_jb.dat
#savestate gcx2 1 ijk 0 A 3 ../data_out/gcx2_jb.dat

#goto FINRUN

##OBSERVATION
xwriteout 50 obs_48 ../data_out/exp_T.nc
savestate sshb  1   ij   50    A       1       ../data_out/sshb_obs_48.dat   
savestate tb  1   ijk   50    A       1       ../data_out/tb_obs_48.dat   
savestate sb  1   ijk   50    A       1       ../data_out/sb_obs_48.dat   
savestate ub  1   ijk   50    A       1       ../data_out/ub_obs_48.dat   
savestate vb  1   ijk   50    A       1       ../data_out/vb_obs_48.dat   
GOTO TESTAD 

loadobs sshb  1   ij   50    A       1       ../data_out/sshb_obs_48.dat D   
loadobs tb  1   ijk   50    A       1       ../data_out/tb_obs_48.dat D   
loadobs sb  1   ijk   50    A       1       ../data_out/sb_obs_48.dat D   
loadobs ub  1   ijk   50    A       1       ../data_out/ub_obs_48.dat D   
loadobs vb  1   ijk   50    A       1       ../data_out/vb_obs_48.dat D   

GOTO FINTEST 
#TEST DE L'ADJOINT'
TESTAD
testad  1.e-01
stop
#-----------------
#TEST DE LA PROGRAMMATION DES DERIVEES
TESTDF
testdf 3  3  1  4    f 1.e-10  0.001  10
stop
#-----------------
# TEST DE LINEAIRE TANGENT
TESTLT
 testlt 1.e+00 0.5e-01 2. 15
stop
FINTEST
#goto FINRUN

##INITIALISATION DE L'ASSIMILATION'
xistate_init 1 ../data_in/file_rest/GYRE_00000400_restart.nc
load_eb ta_c  // charger l'ebauche '
setstate nu 0
outoebx nu 1 0
set_bcoef nu 1.e-16
set_modeltime 0
print_time OFF
FORWARD

xwriteout 0 init ../data_out/exp_T.nc
xwriteout 50 forw0_48 ../data_out/exp_T.nc

##TEST DE LA FONCTION OBJECTIVE
goto FINTEST
testof 1.e+00 0.5e-01 2. 10 1
goto FINRUN
FINTEST
##DEBUT DE L'ASSIMILATION'
print_cost ON
set_modeltime 0
!echo "RUN OPTIMIZATION WITH M1QN3 ......."
setm_impres  5
setm_io      6
setm_mode    1
set_nbiter   100
setm_nsim    100
setm_dxmin   1.0e-4
setm_epsg    1.0e-10
setm_ddf1    1
runm
##SAUVEGARDE
xwriteout 0 fin ../data_out/exp_T.nc
xwriteout 50 forwfin_48 ../data_out/exp_T.nc

xrst_save ../data_in/file_rest/GYRE_00000400_restart_CONTROL_T.nc



goto FINRUN


FINRUN

